' Vector Class -- supports various operations on 3D vectors, including
'       Add, Subtract, Multiply, Divide, Dot and Cross

' Seems to work to a first aprox, but NEEDS TESTING 
' try some of the test code that is in comments at bottom of class def
' Some of the routines in the orig vectorcls not converted as yet


Imports System.Math


    Public Class VectorCls
    Const Pi = 3.14159265
    Const Zero = 0.000001

        Private mX, mY, mZ As Double   ' the vector components

        Public Property X() As Double
            Get
                Return mX
            End Get
            Set(ByVal Value As Double)
                mX = Value
            End Set
        End Property

        Public Property Y() As Double
            Get
                Return mY
            End Get
            Set(ByVal Value As Double)
                mY = Value
            End Set
        End Property

        Public Property Z() As Double
            Get
                Return mZ
            End Get
            Set(ByVal Value As Double)
                mZ = Value
            End Set
        End Property

        Sub New()
            mX = 0
            mY = 0
            mZ = 0
        End Sub


        Sub New(ByVal X, ByVal Y, ByVal Z)
            mX = X
            mY = Y
            mZ = Z
        End Sub


        ' Magnatude -- return magnatude of me
        Public Function Magnatude() As Double
            Return Sqrt(mX * mX + mY * mY + mZ * mZ)
        End Function


        '	// Return the angle (+CCW in radians) of vectors projection on XY plane 
        '	Real 	HeadingXY() {
        '		Real Denom = sqrt(XCompt*XCompt + YCompt*YCompt);
        '		if (Denom == 0 ) return 0;
        '		Real Angle = acos(fabs(XCompt)/Denom );
        '		if (XCompt>=0 && YCompt>=0) return Angle;
        '		if (XCompt<=0  && YCompt>=0 ) return (Pi - Angle);
        '		if (XCompt<=0  && YCompt<=0 ) return (Pi + Angle);
        '		if (XCompt>=0  && YCompt<=0 ) return (2*Pi - Angle);
        '                return 0;
        '	}

        '    // Return a copy of vector P, rotated by DeltaAnlge (+CCW in radians)
        '    VectorCls RotateXY(float DeltaAngle) {
        '        float CurAngle = HeadingXY();
        '        float NewAngle = CurAngle + DeltaAngle;
        '        VectorCls PRot(cos(NewAngle), sin(NewAngle), 0.0);
        '        return PRot * Magnatude();
        '    }// RotateXY


        '	Unitize -- Return a unitized copy of the current vector
        '				 (does not alter the current vector)
        '	           In a unit vector, the magnatude equals 1.
        Public Function Unitize() As VectorCls
            Dim M As Double
            M = Magnatude()
            Dim N As New VectorCls
            If (M > 0) Then
                N.X = mX / M
                N.Y = mY / M
                N.Z = mZ / M
            End If
            Return N
        End Function


        '	Negate -- Return a copy of the current vector with the signs of all 
        '				components reversed.
        Public Function Negate() As VectorCls
            Dim N As New VectorCls(-mX, -mY, -mZ)
            Return N
        End Function

        '	Test for a Null vector
        Public Function Null() As Boolean
            If ((Abs(mX) < Zero) And (Abs(mY) < Zero) And (Abs(mZ) < Zero)) Then
                Return True
            Else
                Return False
            End If
        End Function

        'Add Vector B to current vector, and return the sum in a new vector
        Public Function Add(ByVal B As VectorCls) As VectorCls
            Dim S As New VectorCls(mX + B.X, mY + B.Y, mZ + B.Z)
            Return S
        End Function


        '	VectorCls operator + (VectorCls B) {
        '		 return VectorCls(XCompt + B.X(), YCompt + B.Y(), ZCompt + B.Z() );
        '	}

        '	Subtract Vector B from the current vector, and return the dif in a new vector
        Public Function Subtract(ByVal B As VectorCls) As VectorCls
            Dim S As New VectorCls(mX - B.X, mY - B.Y, mZ - B.Z)
            Return S
        End Function


        '	Dot Product -- return the dot (inner) product of the current vetor and passed vector
        Public Function Dot(ByVal B As VectorCls) As Double
            Return mX * B.X + mY * B.Y + mZ * B.Z
        End Function


        '	Cross -- return cross product of current vector and passed vector
        Public Function Cross(ByVal B As VectorCls) As VectorCls
            Dim S As New VectorCls(mY * B.Z - mZ * B.Y, _
                                  mZ * B.X - mX * B.Z, _
                                  mX * B.Y - mY * B.X)

            Return S
        End Function


        '	Scalar Mutliply  - return result as vector
        Public Function Multiply(ByVal MM As Double) As VectorCls
            Dim S As New VectorCls(mX * MM, mY * MM, mZ * MM)
            Return S
        End Function




        '	Scalar Divide
        Public Function Divide(ByVal M As Double)
            If (M = 0) Then
                Throw New System.Exception("VectorCls:Divide: div by zero")
            Else
                Dim S As New VectorCls(mX / M, mY / M, mZ / M)
                Return S
            End If
        End Function

    ' AzElevVector -- return a vector in the direction defined by the passed Azimuth and Elevation 
    '       angles (rad).  
    '       Azimuth angle is measured from zero at due South (+X), and is + toward the East (CCW down Y)
    Public Shared Function AzElevVector(ByVal Azimuth As Double, ByVal Elev As Double) As VectorCls
        Dim xc, yc, zc As Double
        xc = Cos(Elev) * Cos(Azimuth)   ' X component of vector
        yc = Cos(Elev) * Sin(Azimuth)   ' Y component of vector
        zc = Sin(Elev)                  ' Z component of vector

        Dim V As New VectorCls(xc, yc, zc)
        Return V
    End Function



        '	// Intersect 2D -- 
        '	//		Return the intersection of the line formed by 
        '	//		start point P1, and direction R1, with a line formed
        '	//		by start point P2, and direction R2.
        '	//		The intersection point is computed using this relationship:
        '	//		P1 + M1*R1 = P2 + M2*R2
        '	//			Where P1, and P2 are vectors to start points of the lines,
        '	//			and R1 and R2 are unit vectors along line, and M1 and M2
        '	//			are magnatudes or R1 and R2 corresponding to intersect point.
        '	// 		All points are assumed to lie in the xy plane.
        '	VectorCls 	IntersectXY(VectorCls 	P1, VectorCls R1,
        '									 VectorCls	P2, VectorCls R2) {	
        '		// check for parallel
        '		VectorCls Ipt(0,0,0);
        '		R1=R1.Unitize(); R2=R2.Unitize();
        '		if ( R1.Dot(R2) != 1.0 ){
        '			Real D = R1.X()*R2.Y() - R2.X()*R1.Y();
        '			if (D != 0 ) {
        '				Real M1 =
        '					(P2.X()*R2.Y() + P1.Y()*R2.X()
        '						- P2.Y()*R2.X() - P1.X()*R2.Y()  ) / D;
        '				Ipt = P1 + R1.Multiply(M1);
        '			}
        '/*
        '			Real D = R1.Y()*R2.X() - R1.X()*R2.Y();
        '			if (D != 0) {
        '				Real M1 = (P2.Y()*R2.X() + R2.Y()*P1.X() - P2.X()*R2.Y() )/ D;
        '				Ipt = P1 + R1 * M1;
        '			}
        '*/
        '		}
        '		return Ipt;
        '	}// IntersectXY

        '	// Intersect 2D -- 
        '	//		Return the intersection of the line formed by 
        '	//		start point P1, and direction R1, with a line formed
        '	//		by start point P2, and direction R2.
        '	//		The intersection point is computed using this relationship:
        '	//		P1 + M1*R1 = P2 + M2*R2
        '	//			Where P1, and P2 are vectors to start points of the lines,
        '	//			and R1 and R2 are unit vectors along line, and M1 and M2
        '	//			are magnatudes or R1 and R2 corresponding to intersect point.
        '	// 		All points are assumed to lie in the xz plane.
        '// Note this XZ version was derived from the XY version, and has
        '//      not been tested.
        '	VectorCls 	IntersectXZ(VectorCls 	P1, VectorCls R1,
        '									 VectorCls	P2, VectorCls R2) {	
        '		// check for parallel
        '		VectorCls Ipt(0,0,0);
        '		R1=R1.Unitize(); R2=R2.Unitize();
        '		if ( R1.Dot(R2) != 1.0 ){
        '			Real D = R1.X()*R2.Z() - R2.X()*R1.Z();
        '			if (D != 0 ) {
        '				Real M1 =
        '					(P2.X()*R2.Z() + P1.Z()*R2.X()
        '						- P2.Z()*R2.X() - P1.X()*R2.Z()  ) / D;
        '				Ipt = P1 + R1.Multiply(M1);
        '			}
        '		}
        '		return Ipt;
        '	}// IntersectXZ


        ' Print value of point on screen
        Public Sub Dump()
        Console.WriteLine("Vector:  {0}  {1}  {2}", mX, mY, mZ)
        End Sub



        '#if 0 // test code
        'main () {

        '    printf("Test Rotate\n");
        '	VectorCls P1(10,10,0); 	       P1.Dump();
        '    VectorCls Pr;
        '    Pr = P1.RotateXY( 0/57.296);  printf("by   0  "); Pr.Dump();
        '    Pr = P1.RotateXY( 45/57.296); printf("by  45  "); Pr.Dump();
        '    Pr = P1.RotateXY( 90/57.296); printf("by  90  "); Pr.Dump();
        '    Pr = P1.RotateXY(180/57.296); printf("by 180  "); Pr.Dump();
        '    Pr = P1.RotateXY(360/57.296); printf("by 360  "); Pr.Dump();
        '    Pr = P1.RotateXY( 20/57.296); printf("by  20  "); Pr.Dump();
        '    Pr = P1.RotateXY(-45/57.296); printf("by -45  "); Pr.Dump();
        '    Pr = P1.RotateXY(720/57.296); printf("by 720  "); Pr.Dump();
        '#if 0
        '	VectorCls R1(1,-1,0);	R1= R1.Unitize();R1.Dump();




        '	printf("P1, R1 and P2, R2 : Ipt\n");
        '	VectorCls P1(-1,2,0); 	P1.Dump();
        '	VectorCls R1(1,-1,0);	R1= R1.Unitize();R1.Dump();
        '	VectorCls P2(0,2,0);	P2.Dump();
        '	VectorCls R2(1,-2,0);	R2.Dump();
        '	VectorCls Ipt(0,0,0);

        '	VectorCls I = Ipt.IntersectXY(P1, R1, P2, R2) ;
        '	I.Dump();

        '	VectorCls Pos(0,0,0);
        '	Pos.Dump();
        '	VectorCls Start(1,2, 3);
        '	Pos = Start + VectorCls(2,4,6);
        '	Pos.Dump();
        '	Start.Dump();
        '	Pos = Pos + Start;
        '	Pos.Dump();

        '	VectorCls A = VectorCls(1,1,1);
        '	VectorCls B = VectorCls(1,2,3);
        '	VectorCls C = VectorCls(-2,-2,-2);
        '	VectorCls S = VectorCls(0,0,0);	

        '	cout << "A: "; A.Dump();
        '	cout << "B: "; B.Dump();
        '	cout << "C: "; C.Dump();

        '	cout << "S = A.Unitize(): S= "; S = A.Unitize(); S.Dump(); 
        '	cout << "A = A.Negate():  A= "; A = A.Negate();  A.Dump();
        '	cout << "B=B.Unitize():   B= "; B = B.Unitize(); B.Dump();
        '	cout << "C = C.Negate():  C= "; C = C.Negate();  C.Dump();
        '	cout << "S = C.Negate():  S= "; S = C.Negate();  S.Dump();
        '	VectorCls XX = VectorCls(4,4,4);

        '	C.Set(2,2,4);
        '	C.Dump();
        '	cout << "mag of C " << C.Magnatude() << "\n";

        '	C.Unitize();
        '	C.Dump();
        '	C.Set(0,0,1);
        '	S = A.Add(B);
        '	S = S.Add(C);
        '	S.Dump();
        '	S.Negate();
        '	S.Dump();
        '	S = S.Subtract(A);
        '	S.Dump();

        '	cout << "A dot B " << A.Dot(B) << "\n";
        '	cout << "B dot B " << B.Dot(B) << "\n";
        '	cout << "B dot C " << B.Dot(C) << "\n";
        '	A.Set(1,1,1);
        '	cout << "1,1,1 dot B" << B.Dot(A);

        '	A.Dump();
        '	B.Dump();

        '	cout << "A cross B "	;
        '	S = A.Cross(B);
        '	S.Dump();
        '	cout << "B cross A "	;
        '	S = B.Cross(A);
        '	S.Dump();
        '	cout << "A cross C "	;
        '	S = A.Cross(C);
        '	S.Dump();
        '	cout << "C cross B "	;
        '	S = C.Cross(B);
        '	S.Dump();
        '#endif
        '}	
        '#End If


    End Class


